package Mapit;

require 5.005_62;
use strict;
use warnings;

use Data::Dumper;
use XML::DT;
use GD;

require Exporter;

# Module Stuff
our @ISA = qw(Exporter);
our %EXPORT_TAGS = ( 'all' => [ qw() ] );
our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );
our @EXPORT = qw(
     &mapit_new &mapit_load &mapit_cgi_show
);

# Version
our $VERSION = '0.04';

($INC{"Mapit.pm"} =~ m!\.pm$!);
our $pngdir = $`;

sub divide {
  my $self = shift;
  my $img = shift;
  my %areas=(@_)?@_ : ();

  print STDERR "loading (up|down|left|right|home).png...\n";
  my ($up,$right,$down,$left,$home) = load_icons();

  my ($x,$y);
  # Initialize clicable map for 'menu' image.
  my $imamap= "<MAP NAME=\"$self->{name}\">\n";

  # For all divisions, work, work
  for $x (0..$self->{divisions}{'x'}-1) {
    for $y (0..$self->{divisions}{'y'}-1) {

      # Construct file name
      my $crop_name = "$self->{name}.$x.$y.png";
      print STDERR "writing $crop_name...\n";

      # Create cropped map, and copy the image to it
      my $image = new GD::Image($self->{crops}{width},$self->{crops}{height});
      $image->copyResized($img, 0, 0,
			  ($x*3*$self->{crops}{width}/4)-$self->{backs}{'x'},
			  ($y*3*$self->{crops}{height}/4)-$self->{backs}{'y'},
			  $self->{crops}{width},$self->{crops}{height},
			  $self->{crops}{width},$self->{crops}{height});

      # Copy the arrows
      $image->copy( $up   ,$self->{crops}{width}/2-25, 0              ,0,0,50,50) if ($y > 0);
      $image->copy( $left , 0              ,$self->{crops}{height}/2-25,0,0,50,50) if ($x > 0);
      $image->copy( $right,$self->{crops}{width}-50  ,$self->{crops}{height}/2-25,0,0,50,50) if ($x < $self->{divisions}{'x'}-1);
      $image->copy( $down ,$self->{crops}{width}/2-25,$self->{crops}{height}-50  ,0,0,50,50) if ($y < $self->{divisions}{'y'}-1);
      $image->copy( $home , 0              , 0              ,0,0,50,50);

      # open cropped file and write it!
      open(G, "> $self->{directory}/$crop_name") or die("Cannot open file $self->{directory}/$crop_name! ($!)");
      print G $image->png;
      close G;

      # add to the global image map
      $imamap .= "<AREA COORDS=\"";
      $imamap .= int((($x*3*$self->{crops}{width}/4)) * $self->{crops}{width}/$self->{ficticial}{width}).',';
      $imamap .= int((($y*3*$self->{crops}{height}/4)) *
		     ($self->{crops}{width}*$self->{original}{height}/$self->{original}{width})/$self->{ficticial}{height}).',';
      $imamap .= int((($x*3*$self->{crops}{width}/4) + $self->{crops}{width}) * $self->{crops}{width}/$self->{ficticial}{width}).',';
      $imamap .= int((($y*3*$self->{crops}{height}/4)+ $self->{crops}{height})*
		     ($self->{crops}{width}*$self->{original}{height}/$self->{original}{width})/$self->{ficticial}{height}).',';
      $imamap .= "\" HREF=\"$self->{name}.$x.$y.html\">\n";

      # open the HTML page for navigation
      open HTML, "> $self->{directory}/$self->{name}.$x.$y.html" or die("Cannot open file $self->{directory}/$self->{name}.$x.$y.html! ($!)");

      # print hte HTML
      print HTML "<html><head></head><body bgcolor=\"#ffffff\"><center>";
      print HTML "<map name=\"zbr\">\n";
      print HTML join("\n",@{$areas{$x}{$y}}) if (defined($areas{$x}{$y}));
      print HTML " <AREA COORDS=\"0,0,50,50\" HREF=\"$self->{name}.html\">\n";
      print HTML
	  " <AREA COORDS=\"0,50,50,".($self->{crops}{height}-50)."\" HREF=\"$self->{name}.".($x-1).".$y.html\">\n"
	      if ($x);
      print HTML 
	  " <AREA COORDS=\"50,0,".($self->{crops}{width}-50).",50\" HREF=\"$self->{name}.$x.".($y-1).".html\">\n"
	      if ($y);
      print HTML 
	  " <AREA COORDS=\"".($self->{crops}{width}-50).",50,$self->{crops}{width},".($self->{crops}{height}-50)."\" HREF=\"$self->{name}.".($x+1).".$y.html\">\n"
	      if ($x<$self->{divisions}{'x'}-1);
      print HTML 
	  " <AREA COORDS=\"50,".($self->{crops}{height}-50).",".($self->{crops}{width}-50).",$self->{crops}{height}\" HREF=\"$self->{name}.$x.".($y+1).".html\">\n"
	      if ($y<$self->{divisions}{'y'}-1);
      print HTML "</map>\n";
      print HTML "<img src=\"$self->{name}.$x.$y.png\" usemap=\"#zbr\">";
      print HTML "</center></body></html>";
      close HTML;
    }
  }

  $imamap .= "</map>\n";

  # Write the scalled menu map
  print STDERR "writing $self->{name}.out.png...\n";
  my $sim = new GD::Image($self->{crops}{width},$self->{crops}{width}*$self->{original}{height}/$self->{original}{width});
  $sim->copyResized($img,0,0,0,0,
		    $self->{crops}{width},    int($self->{crops}{width}*$self->{original}{height}/$self->{original}{width}),
		    $self->{original}{width}, $self->{original}{height});
  open(G, ">$self->{directory}/$self->{name}.out.png") or die("Cannot open file $self->{directory}/$self->{name}.out.png! ($!)");
  print G $sim->png;
  close G;

  print STDERR "writing $self->{name}.html...\n";
  # write the html file for the scalled map menu
  open S, ">$self->{directory}/$self->{name}.html" or die("Cannot open file $self->{directory}/$self->{name}.html! ($!)");
  print S "<html><head></head><body bgcolor=\"#ffffff\"><center>";
  print S $imamap;
  print S "<img src=\"$self->{name}.out.png\" usemap=\"#$self->{name}\">";
  print S "</center></body></html>";
  close S;

  return $imamap;
}

sub load_icons {
  my ($up,$left,$down,$right,$home);
  # Open the 'up' arrow.
  open (UP,"$pngdir/up.png") || die ("cannot open '$pngdir/up.png':$!");
  $up = newFromPng GD::Image(\*UP) || die ("no memory?");
  $up->transparent($up->colorClosest(255,0,0));
  close UP;

  # Open the 'left' arrow.
  open (LEFT,"$pngdir/left.png") || die ("cannot open '$pngdir/left.png':$!");
  $left = newFromPng GD::Image(\*LEFT) || die ("no memory?");
  $left->transparent($left->colorClosest(255,0,0));
  close LEFT;

  # Open the 'right' arrow.
  open (RIGHT,"$pngdir/right.png") || die ("cannot open '$pngdir/right.png':$!");
  $right = newFromPng GD::Image(\*RIGHT) || die ("no memory?");
  $right->transparent($right->colorClosest(255,0,0));
  close RIGHT;

  # Open the 'down' arrow.
  open (DOWN,"$pngdir/down.png") || die ("cannot open '$pngdir/down.png':$!");
  $down = newFromPng GD::Image(\*DOWN) || die ("no memory?");
  $down->transparent($down->colorClosest(255,0,0));
  close DOWN;

  # Open the 'home' arrow.
  open (HOME,"$pngdir/home.png") || die ("cannot open '$pngdir/home.png':$!");
  $home = newFromPng GD::Image(\*HOME) || die ("no memory?");
  $home->transparent($home->colorClosest(255,0,0));
  close HOME;

  return ($up,$right,$down,$left,$home);
}


###########################################################################
#
# mapit_new - given a png map, this function creates a new Mapit object
#
# Arguments:
#  - png file name.
#  - destination directory for the map directory. If the directory
#    with the map name exists, Mapit tries to remove it! (all files)
#  - a reference to an associative array mapping x to the width
#    of the cropped maps. It can map y to the height of the cropped map, too.
#
# The name of the map will be the name of the file, without the .png extension.
#
# You can give another name, using the associative array (a map from 'name' to the
# name to be used).
#
sub mapit_new {
  my ($x,$y);
  my ($file,$img,$dd);
  my ($up,$left,$right,$down,$home);
  my %self;

  # get file name
  $file = shift;
  unless (-f $file) {
    $file = ($file=~/\.png$/)?$file:"$file.png";
  }

  # get destination directory
  $dd = shift or die("You didn't supply a destination directory");
  $dd.="/" unless ($dd =~ m!/$! );

  # get values associative array
  my $t = shift;
  my %values = ();
  %values = %{ $t } if ($t);

  # get map name
  if ($values{name}) {
    $self{name} = $values{name};
  } else {
    $file =~ m!([^/.]+)(\.png)?$!;
    $self{name} = $1;
  }

  chomp(my $current_dir = `pwd`);

  # create map directory
  print STDERR "making directory...\n";
  if (-d "$dd$self{name}") {
    chdir ("$dd$self{name}") ||
      die ("Directory $dd$self{name} exists but I have no permissions to use it!");
    my @files = <*>;
    if (@files == unlink @files) {
    } else {
      die ("Cannot delete files under $dd$self{name}!");
    }
  } else {
    `mkdir $dd$self{name}`;
  }
  chdir($current_dir);

  # get the directory
  ($self{directory}) = `cd $dd$self{name}; pwd; cd -`;
  chomp($self{directory});
  print STDERR "\t\t\t$self{directory}\n";

  # load map file
  print STDERR "loading $file...\n";
  die ("Cannot open file $file") unless -f $file;
  `cp $file $dd$self{name}/$self{name}.orig.png`;
  open PNG, "$dd$self{name}/$self{name}.orig.png"
    or die ("Cannot open file $file!");
  $img = newFromPng GD::Image(\*PNG) or die("Cannot load image: $!\n");
  close PNG;


  # Get image dimensions
  ($self{original}{width},$self{original}{height}) = $img->getBounds();
  print STDERR "file is $self{original}{width} x $self{original}{height}...\n";

  # Calculate number of divisions for X and Y
  $self{crops}{width} = $values{'x'} || 600;
  $self{divisions}{'x'} = int(($self{original}{width}-$self{crops}{width})/(3*$self{crops}{width}/4)+1)+1;

  $self{crops}{height} = $values{'y'} || 400;
  $self{divisions}{'y'} = int(($self{original}{height}-$self{crops}{height})/(3*$self{crops}{height}/4)+1)+1;

  print STDERR "$self{divisions}{x} x $self{divisions}{y} divisions...\n";

  # Calculate ficticial dimensions for correct cropping
  $self{ficticial}{width}  = int(($self{divisions}{'x'}-1)*(3*$self{crops}{width} /4)+$self{crops}{width});
  $self{ficticial}{height} = int(($self{divisions}{'y'}-1)*(3*$self{crops}{height}/4)+$self{crops}{height});
  print STDERR "Ficticial dimensions are $self{ficticial}{width} x $self{ficticial}{height}...\n";

  # Calculate offset of original map relatively to the ficticial dimensions.
  $self{backs}{'x'} = ($self{ficticial}{width}-$self{original}{width})/2;
  $self{backs}{'y'} = ($self{ficticial}{height}-$self{original}{height})/2;

  my $imamap = divide(\%self,$img);

  print STDERR "writing $self{name}.xml...\n";
  # write the xml data file for the map
  open XML, ">$dd$self{name}/$self{name}.xml" or die("Cannot open file $dd$self{name}/$self{name}.xml! ($!)");
  print XML mapit_xml(\%self);
  close XML;

  print STDERR "writing $self{name}.dot...\n";
  #write the dots file for the map
  open DOT, ">$dd$self{name}/$self{name}.dot" or die("Cannot open file $dd$self{name}/$self{name}.dot! ($!)");
  print DOT "<information>\n";
  print DOT "</information>\n";
  close DOT;

  print STDERR "\n\t\t\t\tDONE!\n\n";
  return bless(\%self);
}

###########################################################################
#
# mapit_load - given the directory, it loads all map data and returns a
#              new object
#
# argument: path_to_the_map_directory
#
sub mapit_load {
  my $dir = shift;
  $dir =~ m!/?([^/]+)/?$!;
  my $name = $1;
  my %h = (
	   '-type'      => { map => 'MAP' },
	   '-inputenc'  => 'ISO-8859-1',
	   '-outputenc' => 'ISO-8859-1',
	   '-default'   => sub { $c },
	   'original'   => sub { +{ width => $v{width}, height => $v{height} } },
	   'divisions'  => sub { +{   x   =>   $v{x}  ,  'y'   => $v{'y'}    } },
	   'crops'      => sub { +{ width => $v{width}, height => $v{height} } },
	   'ficticial'  => sub { +{ width => $v{width}, height => $v{height} } },
	   'backs'      => sub { +{   x   =>   $v{x}  ,  'y'   => $v{'y'}    } },
	  );
  if (-f "$dir/$name.xml") {
    my %self = %{dt("$dir/$name.xml",%h)};
    $self{name}=$name;
    return bless(\%self);
  } else {
    die ("Cannot load any map from that directory!");
  }
}

###########################################################################
#
# Auxilliary function: takes the mapit object and returns it's XML
#
sub mapit_xml {
  my $t = shift;
  return <<END;
  <map name="$t->{name}">
   <directory>$t->{directory}</directory>
   <original width="$t->{original}{width}" height="$t->{original}{height}"/>
   <divisions x="$t->{divisions}{x}" y="$t->{divisions}{y}"/>
   <crops width="$t->{crops}{width}" height="$t->{crops}{height}"/>
   <ficticial width="$t->{ficticial}{width}" height="$t->{ficticial}{height}"/>
   <backs x="$t->{backs}{x}" y="$t->{backs}{y}"/>
  </map>
END
}

###########################################################################
#
# get_map - auxilliary function. returns a png;
#
# Arguments:
#      - the fullname to the file: $path$name (withdout extensions)
#      - the x coords
#      - the y coords
#
sub get_map {
  my ($fullname,$x,$y) = @_;
  my $img;
  if ($x == -1 || $y == -1) {
    open PNG, "$fullname.out.png" or die ("Cannot open file! $fullname.out.png");
    $img = newFromPng GD::Image(\*PNG) or die("Cannot load image: $!\n");
    close PNG;
  } else {
    open PNG, "$fullname.$x.$y.png" or die ("Cannot open file! $fullname.$x.$y.png");
    $img = newFromPng GD::Image(\*PNG) or die("Cannot load image: $!\n");
    close PNG;
  }

  return $img;
}

###########################################################################
#
# mapit_cgi_show - given CGI parameters reference, shown the respective map
#
# CGI arguments MUST include: directory, name, x and y
#
sub mapit_cgi_show {
  my $param = shift;
  my ($x,$y);
  my $map = get_map("$param->{directory}/$param->{name}",$param->{'x'},$param->{'y'});
  if ($x == -1 || $y == -1) {
  } else {
    while($param->{coords}=~/(\d+)\s*,\s*(\d+)/g) {
      draw_dot($map,$1,$2);
      if (defined($x) && defined($y)) {
	draw_dup_line($map,$x,$y,$1,$2);
      }
      ($x,$y)=($1,$2);
    }
  }
  binmode STDOUT;
  print $map->png;
}


###########################################################################
#
# Method to be called to edit map (add dot, area or line)
#
# Argument:
#         - the full name to the CGI that calls 'mapit_cgi_show'
#         - a reference to the CGI parameters hash
#
sub edit {
  my $self = shift;
  my $script = shift;
  my $param = shift;
  my %param = %{$param};
  my $text = "<center>";
  my $coords;

  if ($param{nome}) {
    $param{xml} = "$self->{directory}/$self->{name}.dot";

    my $xml = "";
    if (defined($param{radio})) {
      if ($param{radio} eq "Area") {
	$xml.= "<area coords=\"$param{coords}\">\n";
	$xml.= " <title>$param{nome}</title>\n";
	$xml.= " <url>$param{url}</url>\n";
	$xml.= " <description>$param{desc}</description>\n";
	$xml.= "</area>";
      } else {
	$xml.= "<line coords=\"$param{coords}\">\n";
	$xml.= " <title>$param{nome}</title>\n";
	$xml.= " <url>$param{url}</url>\n";
	$xml.= " <descriptions>$param{desc}</descriptions>\n";
	$xml.= "</line>";
      }
    } else {
      $xml.= "<dot coords=\"$param{coords}\">\n";
      $xml.= " <title>$param{nome}</title>\n";
      $xml.= " <url>$param{url}</url>\n";
      $xml.= " <descriptions>$param{desc}</descriptions>\n";
      $xml.= "</dot>";
    }

    if (-e $param{xml}) {
	open XML, "$param{xml}" or die("Cannot open file: $param{xml}\n");
	my $oslash = $/;
	undef($/);
	my $texto = <XML>;
	$/ = $oslash;
	close XML;
	$texto=~s!</information>!"\n" .$xml. "\n</information>"!e;
	open XML, ">$param{xml}" or die("Cannot write file: $param{xml} (no permissions?)\n");
	print XML $texto;
	close XML;
    }
    else {
	open XML,">$param{xml}" or die("cannot create file: $param{xml} (no permissions?)\n");
	print XML "<information>\n";
	print XML $xml;
	print XML "\n</information>";
	close XML;
      }

    return "<h1 align=\"center\">Done</h1>";
  } else {
    # Any special window? if no, the top left corner!
    $param{'x'}||=0;
    $param{'y'}||=0;

    if ($param{'x'} == -1 || $param{'y'} == -1) {
      $coords = $param{coords};
      # using ponto.x and ponto.y, decide what param{x} and param{y}
      $param{'x'} = $param{'y'} = 1;
    } else {
      # see if the user wants to navigate...
      if ($param{'ponto.x'} > $self->{crops}->{width} -50 &&
	  $param{'ponto.y'} < $self->{crops}->{height}-50 &&
	  $param{'ponto.y'} > 50) {
	######### TO THE RIGHT ##############################################
	$coords = $param{coords};
	$param{'x'}++ unless ($self->{divisions}->{'x'}==$param{'x'}+1);

      } elsif ($param{'ponto.x'} < 50 &&
	       $param{'ponto.y'} < $self->{crops}->{height}-50 &&
	       $param{'ponto.y'} > 50) {
	######### TO THE LEFT ###############################################
	$coords = $param{coords};
	$param{'x'}-- unless ($param{'x'}==0);

      } elsif ($param{'ponto.y'} < 50 &&
	       $param{'ponto.x'} < $self->{crops}->{width}-50 &&
	       $param{'ponto.x'} > 50) {
	######### UPSTAIRS ##################################################
	$coords = $param{coords};
	$param{'y'}-- unless ($param{'y'}==0);

      } elsif ($param{'ponto.y'} > $self->{crops}->{height}-50 &&
	       $param{'ponto.x'} < $self->{crops}->{width} -50 &&
	       $param{'ponto.x'} > 50) {
	######### DOWNSTAIRS ################################################
	$coords = $param{coords};
	$param{'y'}++ unless ($param{'y'}+1==$self->{divisions}->{'y'});

      } elsif ($param{'ponto.y'} < 50 && $param{'ponto.x'} < 50) {
	######### INDEX ######################################################
	$coords = $param{coords};
	$param{'y'} = $param{'x'} = -1;

      } else {
	######### OK... it clicked somewhere else ############################
	my ($unx,$uny) = pixels2_($param{'x'},$param{'y'},
				  $param{'ponto.x'},$param{'ponto.y'},$self);
	if ($param{coords}) {
	  $coords = "$param{coords},$unx,$uny";
	} else {
	  $coords = "$unx,$uny";
	}
      }
    }

    # get coordinates and convert them...
    my @coords = split /\s*,\s*/, $coords;
    my $ncoords = $#coords;
    my $cords;
    while (@coords) {
      my ($x,$y) = _2pixels(shift(@coords),shift(@coords),$self);
      my ($mx,$my,$dx,$dy) = global2concrete($x,$y,$self);
      if ($mx==$param{'x'} && $my==$param{'y'}) {
	$cords.="," if $cords;
	$cords.="$dx,$dy"
      } elsif ($mx+1==$param{'x'} && $my==$param{'y'} && ($dx-=$self->{crops}->{width}*3/4)>0) {
	$cords.="," if $cords;
	$cords.="$dx,$dy"
      } elsif ($mx==$param{'x'} && $my+1==$param{'y'} && ($dy-=$self->{crops}->{height}*3/4)>0) {
	$cords.="," if $cords;
	$cords.="$dx,$dy"
      } elsif ($mx+1==$param{'x'} && $my+1==$param{'y'} &&
	       ($dy-=$self->{crops}->{height}*3/4)>0 && ($dx-=$self->{crops}->{width}*3/4)>0) {
	$cords.="," if $cords;
	$cords.="$dx,$dy"
      }
    }

    #
    #  PUT THE PICTURE FORM
    #
    $text .= <<EOT;
    <form method="POST" enctype="application/x-www-form-urlencoded">
      <input type="hidden" name="x" value="$param{x}">
     <input type="hidden" name="y" value="$param{y}">
     <input type="hidden" name="coords" value="$coords">
     <input type="image" name="ponto" width="$self->{crops}->{width}" height="$self->{crops}->{height}"
            src="$self->{script}?directory=$self->{directory}&name=$self->{name}&x=$param{x}&y=$param{y}&coords=$cords">
    </form>
EOT


  # If ncoords>=1, then we can insert anything...
  if ($ncoords >= 1) {
    # if ncoords =1, then we can only insert a dot...
    if ($ncoords == 1) {
      $text .= <<EOT;
      <table border="1" cellspacing="0" cellpadding="5"><tr><td>
	<b>Dot:</b>
EOT

  while($coords=~/(\d+(\.\d+)?),(\d+(\.\d+)?)/g) {
    $text.="<tt>$1, $3</tt>\n";
  }

$text .= <<EOT;
    <form method="POST" enctype="application/x-www-form-urlencoded">
      <input type="hidden" name="coords" value="$coords">
      <table><tr><td>
      Name: </td><td><input name="nome" size="40"></td></tr>
	<tr><td>URL: </td><td><input name="url" size="40"></td></tr>
	<tr><td>Description:</td><td><textarea name="desc" cols="40" rows="5"></textarea>
	</td><tr></table>
	<hr><div align="right"><input type="submit" value="  Save it  "></div>
      </td></tr></table>
    </form>
EOT

    } else {
      $text.= "<table border=\"1\" cellspacing=\"0\" cellpadding=\"5\"><tr><td>\n";
      $text.= "<b>Area/Line:</b>";
      while($coords=~/(\d+(\.\d+)?),(\d+(\.\d+)?)/g) {
	$text.="<li>$1, $3</li>\n";
      }
      $text.= <<EOT;
    </ul>
     <form method='POST' enctype='application/x-www-form-urlencoded'>
      <input type="hidden" name="coords" value="$coords">
      <input type="radio" name="radio" value="Area" checked="1">Area (so, closed)
      <input type="radio" name="radio" value="Line">Line
      <table><tr><td>Name: </td><td><input name="nome" size="40"></td></tr>
       <tr><td>URL: </td><td><input name="url" size="40"></td></tr>
       <tr><td>Description:</td><td> <textarea name="desc" cols="40" rows="5"></textarea>
      </td><tr></table>
     <hr><div align="right"><input type="submit" value="  Save it  "></div>
     </td></tr></table></form>
EOT
    }
  } else {
    $text .= "<b>Insert dot, line or area. Click on a map point to start</b>";
  }
    $text.= "</center>\n";
    return $text;
  }
}

sub string2array {
  my @coords = split /\s*,\s*/, shift;
  my @ret = ();
  while(@coords) {
    push @ret, [shift @coords, shift @coords];
  }
  return @ret;
}

sub update {
  my $self = shift;
  my ($url,$title,$description);
  my %to_do;
  my $count = 0;
  my %handler = (
		 '-inputenc' => "iso-8859-1",
		 'url' => sub{ $url = $c; toxml },
		 'area' => sub{
		   my @a = string2array($v{coords});
		   $v{id}=++$count;
		   push @{$to_do{area}},
		     {coords => \@a,
		      url => $url,
		      id => $v{id},
		      title => $title,
		      description => $description};
		   undef($url);
		   undef($title);
		   undef($description);

		   toxml;
		 },
		 'line' => sub{
		   my @a = string2array($v{coords});
		   $v{id}=++$count;
		   push @{$to_do{line}},
		     {coords => \@a,
		      url => $url,
		      id => $v{id},
		      title => $title,
		      description => $description};
		   undef($url);
		   undef($title);
		   undef($description);

		   toxml;
		 },
		 'dot' => sub{
		   my ($x,$y) = split /\s*,\s*/,$v{coords};
		   $v{id}=++$count;
		   push @{$to_do{dot}},
		     {'x'=>$x,
		      'y'=>$y,
		      url=>$url,
		      id => $v{id},
		      title=>$title,
		      description=>$description};

		   toxml;
		   },
		 'title' => sub{ $title = $c; toxml;},
		 'information' => sub{toxml},
		 'description' => sub{ $description = $c; toxml},
		);
  my $xml = dt("$self->{directory}/$self->{name}.dot",%handler);

  # Write the dot file with id's
  open XML, ">$self->{directory}/$self->{name}.dot"
    or die ("Cannot open Mapit object files for writting!");
  print XML $xml;
  close XML;

  print STDERR "loading map..\n";
  open PNG, "$self->{directory}/$self->{name}.orig.png"
    or die ("Cannot open Mapit object files!");
  my $img = newFromPng GD::Image(\*PNG) or die("Cannot load image: $!\n");
  close PNG;
  my (%A,%B);
  print STDERR "Drawing dots, lines and areas...\n";
  %A = $self->draw_area($img,@{$to_do{area}});
  $self->draw_line($img,@{$to_do{line}});
  %B = $self->draw_dots($img,@{$to_do{dot}});
  $self->divide($img,my_join(\%A,\%B));
}

sub my_join {
  my $A = shift;
  my $B = shift;
  my ($i,$j);
  my %RET;
  for $i (keys %{$A}) {
    for $j (keys %{$A->{$i}}) {
      $RET{$i}{$j} = $B->{$i}{$j};
      push @{$RET{$i}{$j}}, @{$A->{$i}{$j}};
    }
  }
  return %RET;
}

sub draw_area {
  my $self = shift;
  my $img = shift;
  my @areas = @_;
  my $area;
  my %area;
  for $area (@areas) {
    my @cc;
    my $point = shift @{$area->{coords}};
    my ($x0,$y0) = _2pixels_(@{$point},$self);

    # ...
    my ($a,$b) = _2pixels(@{$point},$self);
    push @cc, [$a,$b];

    my ($fx,$fy) = ($x0,$y0);

    for $point (@{$area->{coords}}) {
      my ($x1,$y1) = _2pixels_(@{$point},$self);

      # ...
      my ($a,$b) = _2pixels(@{$point},$self);
      push @cc, [$a,$b];

      draw_dup_line($img,$x0,$y0,$x1,$y1);
      ($x0,$y0) = ($x1,$y1);
    }
    draw_dup_line($img,$x0,$y0,$fx,$fy);



    $self->create_tip($area->{id},
		      $area->{title},
		      $area->{url},
		      $area->{description});
    my $id = $area->{id};

    my @divs = $self->what_divisions( @cc );
    my $div;
    for $div (@divs) {
      my @dots = $self->coords_for(@{$div},@cc);
      push @{$area{$div->[0]}{$div->[1]}}, ("<area shape=\"poly\"  coords=\"".
					    join(",",map {join ",",@{$_}} @dots).
					    "\" onclick=\"window.open('$self->{name}.tip.$id.html','TIP','toolbar=no,location=1,directories=no,status=no,menubar=0,scrollbars=yes,resizable=1,copyhistory=0,width=200,height=200')\">");
    }
  }
  return %area;
}


sub create_tip {
  my $self = shift;
  my $id = shift;
  my $title = shift;
  my $url = shift || 0;
  my $desc = shift || "";

  $title = "<a href=\"$url\" target=\"_new\">$title</a>" if ($url);

  open TIP, ">$self->{directory}/$self->{name}.tip.$id.html" or die("");
  print TIP <<EOT;
 <html><head><title>$title</title></head>
 <body bgcolor="#ffffdd"><h3>$title</h3><p>$desc</p>
 <div align="right"><a href="" onclick="window.close()">Fechar</a></div>
 </body> </html>
EOT
  close TIP;
}

sub coords_for {
  my $self = shift;
  my ($mx,$my) = (shift, shift);
  my @coords = @_;
  my @ncoords = ();
  for (@coords) {
    my $x = $_->[0]-$mx*$self->{crops}{width}*3/4;
    my $y = $_->[1]-$my*$self->{crops}{height}*3/4;
    push @ncoords, [$x,$y];
  }
  return @ncoords;
}

sub draw_line {
  my $self = shift;
  my $img = shift;
  my @lines = @_;
  my $line;

  return; #So far, don't draw them...
  for $line (@lines) {
    my $point = shift @{$line->{coords}};
    my ($x0,$y0) = _2pixels_(@{$point},$self);

    for $point (@{$line->{coords}}) {
      my ($x1,$y1) = _2pixels_(@{$point},$self);
      draw_dup_line($img,$x0,$y0,$x1,$y1);
      ($x0,$y0) = ($x1,$y1);
    }

  }
}
sub draw_dots {
  my $self = shift;
  my $img = shift;
  my @dots = @_;

  my %areas;

  for (@dots) {
    my ($x,$y) = _2pixels_($_->{'x'},$_->{'y'},$self);
    draw_dot($img,$x,$y);
    ($x,$y) = _2pixels($_->{'x'},$_->{'y'},$self);
    my ($mx,$my,$dx,$dy) = global2concrete($x,$y,$self);

    $self->create_tip($_->{id},
		      $_->{title},
		      $_->{url},
		      $_->{description});
    my $id = $_->{id};


    push @{$areas{$mx}{$my}}, "<area shape=\"circle\" coords=\"$dx,$dy,7\"  onclick=\"window.open('$self->{name}.tip.$id.html','TIP','toolbar=no,location=1,directories=no,status=no,menubar=0,scrollbars=yes,resizable=1,copyhistory=0,width=200,height=200')\">";

    push @{$areas{$mx+1}{$my+1}}, "<area shape=\"circle\"  coords=\"".($dx-$self->{crops}{width}*3/4).",".($dy-$self->{crops}{height}*3/4).",7\" onclick=\"window.open('$self->{name}.tip.$id.html','TIP','toolbar=no,location=1,directories=no,status=no,menubar=0,scrollbars=yes,resizable=1,copyhistory=0,width=200,height=200')\">"
      if ($dx > $self->{crops}{width}*3/4 && $dy > $self->{crops}{height}*3/4);

    push @{$areas{$mx+1}{$my}}, "<area shape=\"circle\"  coords=\"".($dx-$self->{crops}{width}*3/4).",$dy,7\" onclick=\"window.open('$self->{name}.tip.$id.html','TIP','toolbar=no,location=1,directories=no,status=no,menubar=0,scrollbars=yes,resizable=1,copyhistory=0,width=200,height=200')\">"
      if ($dx > $self->{crops}{width}*3/4);

    push @{$areas{$mx}{$my+1}}, "<area shape=\"circle\"  coords=\"$dx,".($dy-$self->{crops}{height}*3/4).",7\" onclick=\"window.open('$self->{name}.tip.$id.html','TIP','toolbar=no,location=1,directories=no,status=no,menubar=0,scrollbars=yes,resizable=1,copyhistory=0,width=200,height=200')\">"
      if ($dy > $self->{crops}{height}*3/4);
  }
  return %areas;
}

sub global2concrete {
  my $x = shift;
  my $y = shift;
  my $map = shift;
  my ($mx,$my,$dx,$dy);
  $mx = $my = 0;
  while ($x>$map->{crops}->{width}) {
    $mx++;
    $x-=int(3*$map->{crops}->{width}/4);
  }
  $dx = $x;

  while ($y>$map->{crops}->{height}) {
    $my++;
    $y-=int(3*$map->{crops}->{height}/4);
  }
  $dy = $y;

  return ($mx,$my,$dx,$dy);
}

# dado um x e um y ambos no intervalo [0,1], e um map hash,
# devolve um x e um y para esse mapa. Nota... converte o y
# para 1-y;
sub _2pixels {
  my $x = shift;
  my $y = 1-shift;
  my $map = shift;
  $x = int($x*$map->{original}->{width} + $map->{backs}->{'x'});
  $y = int($y*$map->{original}->{height}+ $map->{backs}->{'y'});
  return ($x,$y);
}

sub _2pixels_ {
  my $x = shift;
  my $y = 1-shift;
  my $map = shift;
  $x = int($x*$map->{original}->{width} );
  $y = int($y*$map->{original}->{height});
  return ($x,$y);
}

###########################################################################
#
# pixels2_ - auxilliary function. converts map pixels to full [0..1] units
#
# Arguments:
#          - map x
#          - map y
#          - x dot
#          - y dot
#          - map object
#
sub pixels2_ {
  my ($mx,$my,$x,$y,$map) = @_;
  $x=($mx*$map->{crops}->{width}*3/4+$x-$map->{backs}->{'x'})/$map->{original}->{width};
  $y=($my*$map->{crops}->{height}*3/4+$y-$map->{backs}->{'y'})/$map->{original}->{height};
  return ($x,1-$y);
}


# This function receives an image (png) and coordinates in *pixels*,
# returning the image dotted...
sub draw_dot
{
  my ($png,$x,$y) = @_;

  # Allocc colors
  my $red   = $png -> colorAllocate(255, 0 , 0 );
  my $blue  = $png -> colorAllocate( 0 , 0 ,255);
  my $white = $png -> colorAllocate(255,255,255);
  my $black = $png -> colorAllocate( 0 , 0 , 0 );

  # Make the dot
  $png -> arc($x, $y, 10, 10, 0, 360, $red );
  $png -> arc($x, $y, 20, 20, 0, 360, $blue);
  $png -> arc($x, $y, 19, 19, 0, 360, $blue);
  $png -> fillToBorder($x,$y,$red,$red);

  return $png;
}

sub draw_dup_line {
  my ($png,$x1,$y1,$x2,$y2) = @_;
  my $blue = $png -> colorAllocate( 0,0,255 );
  my $red  = $png -> colorAllocate( 255,0,0 );
  $png -> line( $x1 , $y1 , $x2 , $y2 ,$blue);
  $png -> line($x1+1,$y1+1,$x2+1,$y2+1, $red);
  return $png;
}

#
# Send an array of coords ([x1,y1],[x2,y2],...,[xn,yn]) and I
# answer what divisions are used...

sub what_divisions {
  my $self = shift;
  my @coords = @_;
  my %wheres;
  my $c;
  for $c(@coords) {
    my ($mx,$my,$x,$y) = global2concrete(@{$c},$self);
    $wheres{"$mx,$my"}++;
    if ($x>$self->{crops}{width}*3/4) {
      my $mmx = $mx + 1;
      $wheres{"$mmx,$my"}++;
    }
    if ($y>$self->{crops}{height}*3/4) {
      my $mmy = $my + 1;
      $wheres{"$mx,$mmy"}++;
    }
    if ($y>$self->{crops}{height}*3/4 && $x>$self->{crops}{width}*3/4) {
      my ($mmx,$mmy)=($mx+1,$my+1);
      $wheres{"$mmx,$mmy"}++;
    }
  }
  @coords = ();
  for (keys %wheres) {
    my ($a,$b)=split /,/;
    push @coords, [$a,$b];
  }
  return @coords;
}

1;
__END__

=head1 NAME

Mapit - Perl extension for managing geografical information

=head1 SYNOPSIS

  use Mapit;

  $map = mapit_new( "path/and/map/file/name.png",
                    "directory/where/we/want/the/map/dir",
                    +{ x=> 300, y=> 200 } );

  $map = mapit_load( "path/including/the/path/directory" );

  $map -> mapit_draw_dot( x, y, "title", "url" );

  mapit_show( +{directory => '/the/dir',
	        name => 'file',
                x => 3, y => 5} );

=head1 DESCRIPTION

This module should be used when you want an interactive Web map. But,
offcourse It can be used on non web pages, or on non interactive webs.

The basic Mapit object is a map. When you start using Mapit, you need
a city or someplace map. Then, you need that map in a picture file
(digitalize it!). Next, convert to png format. You can use the
ImageMagick B<convert> shell utility or using some program like gimp.
B<Note:> Do not use transparent or alpha png images.

The map you have is, of course, in a big file (Mapit was tested in
a small city and the map has 4 megabytes). You cannot use it directly
in the web. So, the soluction is to crop the image in chunks. These
chunks, all with the same size, will let the user to navigate in
the bigger file.

Now, to start using Mapit, you must decide how many pixels do you want
for the width and height of the map chunks. Typically you will use
something like 700 pixels for the width and 500 for the height.

You have everything you need! Create a perl script doing something
like:

  #!/usr/bin/perl

  use Mapit;
  $map = mapit_new( "york.png",
                    "/www/htdocs/maps",
                    +{ x=> 700, y=> 500 } );

If you run this simple script, and you have a new york map in the
current directory, with the name york.png, then, Mapit will create a
/www/htdocs/maps/york directory (if it exists, it will try to delete
it!!!) with a lot of png and html files. Some xml files will be
created, too!

=head2 mapit_new function

This function should be called at least one time, to compute the
images to be used on the web. The two first arguments are
mandatory. The first one, is the file (it have to be a .png, because
of gif patents) name. The second, is the directory where Mapit will
create the map directory. So, if the filename if 'new-york.png' and
the directory if '/www/htdocs/maps' then, Mapit will create the
/www/htdocs/maps/new-york directory and will create all the files it
needs inside it. If the directory already exists, Mapit tries to
delete all files and directory.

The third argument is optional and is a reference to an associative
array. This array can map B<x>, B<y> and B<name>. The first two will
be used as dimensions (width and height) of the cropped navigation
map. The C<name> one, will be used instead of the file name, as the
map name.

Under the created directory you will find a lot of <name>.<d>.<d>.png>
files (the cropped map files), a lot of <name>.<d>.<d>.html files,
that includes the cropped map files. There will be a <name>.html file
(the main html file) and a <name>.out.png file (the main scalled png).
At last, the <name>.xml file is an XML file with data to be used when
loading a map with Mapit.

The B<mapit_new> function will return a new Mapit object.

=head2 mapit_load function

This function receives a directory path. This path should include the
map path. So, for example, if you created your map under
/www/htdocs/maps and your map name was new-york.png, then, you must
call B<mapit_load> function like this:

  $map = mapit_load("/www/htdocs/maps/new-york");

The function will return a new Mapit object.


=head1 BUGS

Because of the use of some shell commands to retrieve a file complete
directory, it can cause problems under some shells. Tested with bash.

=head1 AUTHOR

Alberto M. Simes <albie@alfarrabio.um.geira.pt>

Based on one script from Jos Joo Almeida for maps crop and
navigation.

=head1 SEE ALSO

perl(1).

=cut

